import time
import sys
import time
sys.path.append("../ei2c")
from ei2c import *

IDREG = 0x00
FWVREG = 0x04
C1IREG = 0x100
C1OREG = 0x104
C2IREG = 0x108
C2OREG = 0x10C
C3IREG = 0x110
C3OREG = 0x114
C4IREG = 0x118
C4OREG = 0x11C
C5IREG = 0x120
C5OREG = 0x124
C6IREG = 0x128
C6OREG = 0x12C
CNTRST = 0X130
CHENREG = 0x200
C1DELREG = 0x204
C2DELREG = 0x208
C3DELREG = 0x20C
C4DELREG = 0x210
C5DELREG = 0x214
C6DELREG = 0x218
C1WDTHREG = 0x21C
C2WDTHREG = 0x220
C3WDTHREG = 0x224
C4WDTHREG = 0x228
C5WDTHREG = 0x22C
C6WDTHREG = 0x230
C1FREQREG = 0x234
C2FREQREG = 0x238
C3FREQREG = 0x23C
C4FREQREG = 0x240
C5FREQREG = 0x244
C6FREQREG = 0x248

CTB_CLK_PER = 50*(10**(-9))
#CTB_CLK_PER = 8*(10**(-9))

if __name__ == "__main__":
  ip   = raw_input("Crate IP or hostname? ")
  user = raw_input("Username? ")
  pwd  = raw_input("Password? ")

  # Wait for proper slot number
  while 1:
    try:
      slot = raw_input("Slot no.? ")
      slot = int(slot)
      testelma  = EI2C(ip, user, pwd)
      break
    except TypeError as e:
      print "Please input a decimal slot number."
    except SlotError as e:
      print e.strerror
    except KeyboardInterrupt:
      sys.exit()
    except:
      print "Unexpected error: ", sys.exc_info()[0]

  # Open I2C connection
  testelma.open()

  bloid = testelma.read(slot, 0x00)
  fwvers = testelma.read(slot, 0x04) & 0xFF

  if ( bloid != 0x54424c4f ) or ( fwvers != 0xff ):
    print "Wrong version number (0x%04x)" % fwvers
    sys.exit(1)

  testelma.write(slot, CHENREG, 0x00);
  testelma.write(slot, CNTRST, 1);
  testelma.write(slot, CNTRST, 0);

  # First, setup the channel enable variable
  chen = 0x00;

  # Setup channel output pulse widths to 1.2us
  testelma.write(slot, C1WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)
  testelma.write(slot, C2WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)
  testelma.write(slot, C3WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)
  testelma.write(slot, C4WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)
  testelma.write(slot, C5WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)
  testelma.write(slot, C6WDTHREG, 1.2*(10**(-6))/CTB_CLK_PER)

  # Setup channel delays and frequencies
  farr = [0,0,0,0,0,0]

  #inp = ""
  #while (inp != 'y') and (inp != 'n'):
  #  inp = raw_input("Enable channel 1? (y/n) ")

  #if (inp == 'y'):
  #  chen |= (1 << 0);
  #  freq = input("  freq (Hz): ")
  #  if (freq > 166000):
  #    freq = 166000
  #    print "Automatically setting channel frequency to 166 kHz."
  #  farr[0] = freq
  #  freq = 1/(freq * CTB_CLK_PER)
  #  testelma.write(slot, C1FREQREG, int(freq))
  #  #print freq
  #  #print hex(int(freq))

  #inp = ""
  #while (inp != 'y') and (inp != 'n'):
  #  inp = raw_input("Enable channel 2? (y/n) ")

  #if (inp == 'y'):
  #  chen |= (1 << 1);
  #  freq = input("  freq (Hz): ")
  #  if (freq > 166000):
  #    freq = 166000
  #    print "Automatically setting channel frequency to 166 kHz."
  #  farr[1] = freq
  #  freq = 1/(freq * CTB_CLK_PER)
  #  testelma.write(slot, C2FREQREG, int(freq))
  #  #print freq
  #  #print hex(int(freq))

  #inp = ""
  #while (inp != 'y') and (inp != 'n'):
  #  inp = raw_input("Enable channel 3? (y/n) ")

  #if (inp == 'y'):
  #  chen |= (1 << 2);
  #  freq = input("  freq (Hz): ")
  #  if (freq > 166000):
  #    freq = 166000
  #    print "Automatically setting channel frequency to 166 kHz."
  #  farr[2] = freq
  #  freq = 1/(freq * CTB_CLK_PER)
  #  testelma.write(slot, C3FREQREG, int(freq))
  #  #print freq
  #  #print hex(int(freq))

  #inp = ""
  #while (inp != 'y') and (inp != 'n'):
  #  inp = raw_input("Enable channel 4? (y/n) ")

  #if (inp == 'y'):
  #  chen |= (1 << 3);
  #  freq = input("  freq (Hz): ")
  #  if (freq > 166000):
  #    freq = 166000
  #    print "Automatically setting channel frequency to 166 kHz."
  #  farr[3] = freq
  #  freq = 1/(freq * CTB_CLK_PER)
  #  testelma.write(slot, C4FREQREG, int(freq))
  #  #print freq
  #  #print hex(int(freq))

  #inp = ""
  #while (inp != 'y') and (inp != 'n'):
  #  inp = raw_input("Enable channel 5? (y/n) ")

  #if (inp == 'y'):
  #  chen |= (1 << 4);
  #  freq = input("  freq (Hz): ")
  #  if (freq > 166000):
  #    freq = 166000
  #    print "Automatically setting channel frequency to 166 kHz."
  #  farr[4] = freq
  #  freq = 1/(freq * CTB_CLK_PER)
  #  testelma.write(slot, C5FREQREG, int(freq))
  #  #print freq
  #  #print hex(int(freq))

  inp = ""
  while (inp != 'y') and (inp != 'n'):
    inp = raw_input("Enable channel 6? (y/n) ")

  if (inp == 'y'):
    chen |= (1 << 5);
    freq = input("  freq (Hz): ")
    if (freq > 166000):
      freq = 166000
      print "Automatically setting channel frequency to 166 kHz."
    farr[5] = freq
    freq = 1/(freq * CTB_CLK_PER)
    testelma.write(slot, C6FREQREG, int(freq))
    #print freq
    #print hex(int(freq))

  # Ask how long to run the test
  print "How long would you like to run the test?"
  while 1:
    try:
      hrs = raw_input("  hrs: ")
      hrs = int(hrs)
      if (hrs < 0):
        raise Exception
      break
    except KeyboardInterrupt:
      sys.exit()
    except:
      print "    Hours must be a decimal number >= 0!"

  while 1:
    try:
      mins = raw_input("  mins: ")
      mins = int(mins)
      if (mins < 0):
        raise Exception
      break
    except KeyboardInterrupt:
      sys.exit()
    except:
      print "    Minutes must be a decimal number >= 0!"

  while 1:
    try:
      secs = raw_input("  secs: ")
      secs = int(secs)
      if (secs < 0):
        raise Exception
      break
    except KeyboardInterrupt:
      sys.exit()
    except:
      print "    Seconds must be a decimal number >= 0!"

  # Compute test end time according to current time
  # 
  # time.time() returns time since start of epoch
  # in seconds, so add secs, mins and hrs to that
  start_time = time.time()
  end_time = start_time + secs + 60*mins + 3600*hrs

  # Generate output file named according to current time
  fname = time.strftime("p-%Y-%m-%d-%Hh%M", time.localtime()) + ".txt"
  f     = open(fname, "w")

  # Write current time and start of test to output file
  f.write("------------------------------------------------------------\r\n")
  f.write("%s: starting test\n" % time.strftime("%Y-%m-%d-%Hh%Mm%Ss", time.localtime())) 
  print "%s: starting test" % time.strftime("%Y-%m-%d-%Hh%Mm%Ss", time.localtime())
  f.write("------------------------------------------------------------\r\n")

  # Enable the needed channels and start generating pulses
  testelma.write(slot, CHENREG, chen)

  # Run test loop for the specified time
  while time.time() < end_time:
    pass

  # Disable all channels
  while (testelma.read(slot, CHENREG) != 0x00):
    testelma.write(slot, CHENREG, 0x00)


  f.write("%s: ending test\n" % time.strftime("%Y-%m-%d-%Hh%Mm%Ss", time.localtime()))
  print "%s: ending test" % time.strftime("%Y-%m-%d-%Hh%Mm%Ss", time.localtime())
  f.write("------------------------------------------------------------\r\n")
  secs = int(end_time - start_time)
  print "pulses sent:"
  print "ch 1: %d (%d)" % (secs * farr[0], farr[0])
  print "ch 2: %d (%d)" % (secs * farr[1], farr[1])
  print "ch 3: %d (%d)" % (secs * farr[2], farr[2])
  print "ch 4: %d (%d)" % (secs * farr[3], farr[3])
  print "ch 5: %d (%d)" % (secs * farr[4], farr[4])
  print "ch 6: %d (%d)" % (secs * farr[5], farr[5])
  f.write("pulses sent:\n")
  f.write("ch 1: %d (%d)\n" % (secs * farr[0], farr[0]))
  f.write("ch 2: %d (%d)\n" % (secs * farr[1], farr[1]))
  f.write("ch 3: %d (%d)\n" % (secs * farr[2], farr[2]))
  f.write("ch 4: %d (%d)\n" % (secs * farr[3], farr[3]))
  f.write("ch 5: %d (%d)\n" % (secs * farr[4], farr[4]))
  f.write("ch 6: %d (%d)\n" % (secs * farr[5], farr[5]))
  f.write("------------------------------------------------------------\r\n")

  # Read counter registers
  i = testelma.read(slot, C1IREG)
  o = testelma.read(slot, C1OREG)
  f.write("ch %d / i: %d / o: %d\n" % (1, i, o))

  i = testelma.read(slot, C2IREG)
  o = testelma.read(slot, C2OREG)
  f.write("ch %d / i: %d / o: %d\n" % (2, i, o))

  i = testelma.read(slot, C3IREG)
  o = testelma.read(slot, C3OREG)
  f.write("ch %d / i: %d / o: %d\n" % (3, i, o))

  i = testelma.read(slot, C4IREG)
  o = testelma.read(slot, C4OREG)
  f.write("ch %d / i: %d / o: %d\n" % (4, i, o))

  i = testelma.read(slot, C5IREG)
  o = testelma.read(slot, C5OREG)
  f.write("ch %d / i: %d / o: %d\n" % (5, i, o))

  i = testelma.read(slot, C6IREG)
  o = testelma.read(slot, C6OREG)
  f.write("ch %d / i: %d / o: %d\n" % (6, i, o))

  testelma.close()

  f.write("------------------------------------------------------------\r\n")

  # Close output file
  f.close()

  # Print output file name
  print
  print "Test results can be found in " + fname
